import React from 'react';
import { storiesOf } from '@storybook/react';
import { TOAST } from '../../../utilities/constants';
import Info from '../__examples__/info';
import Success from '../__examples__/success';
import Warning from '../__examples__/warning';
import ErrorAlert from '../__examples__/error';
import ErrorWithDetailsAlert from '../__examples__/error-with-details';
import CloseToast from '../__examples__/close-toast';
import DurationToast from '../__examples__/duration-toast';
import CustomClassNames from '../__examples__/custom-class-name';
import CustomStyle from '../__examples__/custom-style';
/* eslint-disable react/display-name */

storiesOf(TOAST, module).addDecorator(function (getStory) {
  return /*#__PURE__*/React.createElement("div", {
    className: "slds-p-around_medium"
  }, getStory());
}).add('Info', function () {
  return /*#__PURE__*/React.createElement(Info, null);
}).add('Success', function () {
  return /*#__PURE__*/React.createElement(Success, null);
}).add('Warning', function () {
  return /*#__PURE__*/React.createElement(Warning, null);
}).add('Error', function () {
  return /*#__PURE__*/React.createElement(ErrorAlert, null);
}).add('Error With Details', function () {
  return /*#__PURE__*/React.createElement(ErrorWithDetailsAlert, null);
}).add('Close Toast', function () {
  return /*#__PURE__*/React.createElement(CloseToast, null);
}).add('Duration Toast', function () {
  return /*#__PURE__*/React.createElement(DurationToast, null);
}).add('Custom Class Names', function () {
  return /*#__PURE__*/React.createElement(CustomClassNames, null);
}).add('Custom Style', function () {
  return /*#__PURE__*/React.createElement(CustomStyle, null);
});
//# sourceMappingURL=storybook-stories.js.map